#!/usr/bin/env python

# importing depending modules
import pdb,sys,os,stat,time,shutil
import subprocess
import multiprocessing
import threading
p_version=sys.version_info[0]

python=sys.executable
# checking the version of python
if p_version<=2:
	try:
		import Tkinter
		from Tkinter import *
		from tkFileDialog import askopenfilename
	except:
		print ("Please install the Tkinter module first!")
		time.sleep(10)
		sys.exit(0)
		
elif p_version>=3:
	try:
		import tkinter
		from tkinter import *
		from tkinter.filedialog import askopenfilename
	except:
		print ("please install the tkinter module first!")
		time.sleep(10)
		sys.exit(0)
	

import webbrowser
########################################################################




########################################################################

########################################################################

class App:
	def __init__(self,master):
		
		###zero frame##################################################
		fheader=Frame(master)
		self.label_title=Label(fheader,text="Welcome to use miRHMM", fg="black",font="Helvetica 16 bold italic")
		self.label_id=Label(fheader,text="Data Integration and Knowledge Discovery Lab\n University of Central Florida", fg="black",font="Times 10 bold italic")
		
		#pack manager
		self.label_title.pack(padx=6)
		self.label_id.pack(padx=6)
		fheader.pack(fill="x",pady=4)
		
		
		
		sep0=Frame(master,height=2,bd=1,relief=SUNKEN)
		sep0.pack(fill="x",pady=4)
		
		##first frame###################################################
		##file opener---------------------------------------------------
		wid=40
		fop=Frame(master)
		self.button1=Button(fop,text="Choose your input target sequence (-b):",fg="black",command=self.load_file,width=wid,bg="gray")
		self.v=StringVar()
		self.label1=Label(fop,textvariable=self.v,bg="gray",width=20)
		self.button1.pack(side=LEFT,padx=6)
		self.label1.pack(side=LEFT,padx=20)
		self.label12=Label(fop,text="(e.g.:example.seq in the 'example' folder)")
		self.label12.pack(side=LEFT)
		fop.pack(fill="x",pady=6)
		
	
		
		##Second Frame###################################################
		## inputting parameters-----------------------------------------
		sf=Frame(master,borderwidth=1,relief=SUNKEN,pady=6)
		self.button2=Button(sf,text="Choose your input miRNA sequence (-a):",fg="black",command=self.load_mir,width=wid,bg="gray")
		self.v2=StringVar()
		self.label2=Label(sf,textvariable=self.v2,bg="gray",width=20)
		self.button2.pack(side=LEFT,padx=6)
		self.label2.pack(side=LEFT,padx=20)
		self.label22=Label(sf,text="(e.g.:example_mirna.seq)")
		self.label22.pack(side=LEFT)
		sf.pack(fill="x",pady=6)
		
		
		
		##Third Frame#################################################
		tf=Frame(master,borderwidth=1,relief=SUNKEN,pady=6)
		self.b=IntVar()
		self.button3=Radiobutton(tf,text="Choose your input miRNA concentration (-c):",fg="black",command=self.load_conc,value=1,variable=self.b,bg="gray",width=wid)
		self.v3=StringVar()
		self.label3=Label(tf,textvariable=self.v3,bg="gray",width=20)
		self.button3.pack(side=LEFT,padx=6)
		self.label3.pack(side=LEFT,padx=20)
		self.label32=Label(tf,text="(e.g.:example_mirna.conc)")
		self.label32.pack(side=LEFT)
		self.button4=Radiobutton(tf,text="no miRNA concentration info", bg="gray",value=2,variable=self.b) 
		self.button4.pack(side=LEFT,padx=6)
		tf.pack(fill="x",pady=6)
		#==============================================================
		## fifty frame
		fff=Frame(master,borderwidth=1,relief=SUNKEN,pady=6)
		self.label5=Label(fff,text="Output Name (-o):",bg="gray",width=(wid+3))
		self.label5.pack(side=LEFT,padx=6)
		self.v5=StringVar()
		self.v52=StringVar()
		self.entry5=Entry(fff,textvariable=self.v5)
		self.entry5.pack(side=LEFT,padx=20)

		fff.pack(fill="x",pady=6)
		
		
		###############################################################
		## fourth frame
		ff=Frame(master,borderwidth=1,relief=SUNKEN,pady=6)
		self.label4=Label(ff,text="Paralleling: Number of CPU cores using (-p):",bg="gray",width=(wid+3))
		self.label4.pack(side=LEFT,padx=6)
		self.v4=StringVar()
		self.entry4=Entry(ff,textvariable=self.v4)
		self.entry4.pack(side=LEFT,padx=20)
		
		ff.pack(fill="x",pady=6)
		
	
		
		
		
		
		
		
		#===================================================================================
		sep2=Frame(master,height=2,bd=1,relief=SUNKEN)
		sep2.pack(fill="x",pady=4)
		fhelp=Frame(master)
		
		go_help=Button(fhelp,text="Go Help!",command=self.openpage)
		go_run=Button(fhelp,text="Run!",command=self.run)
		self.v_end=StringVar()
		self.label_ending=Label(fhelp,textvariable=self.v_end,width=wid)
		##pack manager
		go_help.pack(side="left",padx=6,pady=2)
		go_run.pack(side="left",padx=6,pady=2)
		
		
		#go_stop=Button(fhelp,text="Stop",command=self.stop_run)
		#go_stop.pack(side="left",padx=6,pady=2)
		self.label_ending.pack(side="left",padx=6,pady=2)
		fhelp.pack(fill="x")
		self.p=StringVar()
	
	##file opener function
	
	def load_file(self):
		self.fileName=askopenfilename()
		if self.fileName!="":
			FN=self.fileName.split("/")[-1]
			self.v.set(FN)
	def load_mir(self):
		self.mirName=askopenfilename()
		if self.mirName!="":
			MN=self.mirName.split("/")[-1]
			self.v2.set(MN)
	def load_conc(self):
		self.conc=askopenfilename()
		if self.conc!="":
			CC=self.conc.split("/")[-1]
			self.v3.set(CC)
			
	def openpage(self):
		webbrowser.open_new("readme.txt")
		
	def run(self):
		#self.show_run()
		rb=self.b.get()
		conc=self.v3.get()
		if rb==1:
			self.p=threading.Thread(target=self.trun)
			self.p.start()
		else:
			self.p=threading.Thread(target=self.trun1)
			self.p.start()
		
		
	def trun(self):
		self.v_end.set("running...")
		self.label_ending.update_idletasks()
		subprocess.call([python,"mirhmm.py","-b", "%s"%(self.fileName),"-a","%s"%(self.mirName),"-c","%s"%(self.conc),"-o", "%s"%(self.v5.get()),"-p","%s"%(self.v4.get())])
		self.v_end.set("Done!")
		self.label_ending.update_idletasks()
		
	def trun1(self):
		self.v_end.set("running...")
		self.label_ending.update_idletasks()
		subprocess.call([python,"mirhmm.py","-b", "%s"%(self.fileName),"-a","%s"%(self.mirName),"-o", "%s"%(self.v5.get()),"-p","%s"%(self.v4.get())])
		self.v_end.set("Done!")
		self.label_ending.update_idletasks()
	
########################################################################


# root level
def main():
	root=Tk()
	root.geometry("1000x400+200+200")
	root.title("miRHMM")
	########################################################################
	app=App(root)
	root.mainloop()
	########################################################################

if __name__=='__main__':
	main()
